VTK: vtkX3DExporter Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkX3DExporter Class Reference

create an x3d file More...

`#include <vtkX3DExporter.h>`

Inheritance diagram for vtkX3DExporter:
[legend]
Collaboration diagram for vtkX3DExporter:
[legend]

## Public Types
typedef vtkExporter | Superclass
Public Types inherited from vtkExporter
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkX3DExporter * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
char * | RegisterAndGetOutputString ()
| This convenience method returns the string, sets the IVAR to nullptr, so that the user is responsible for deleting the string. More...
| vtkSetFilePathMacro (FileName)
| Set/Get the output file name. More...
| vtkGetFilePathMacro (FileName)
| Set/Get the output file name. More...
virtual void | SetSpeed (double)
| Specify the Speed of navigation. More...
virtual double | GetSpeed ()
| Specify the Speed of navigation. More...
virtual void | SetBinary (vtkTypeBool)
| Turn on binary mode. More...
virtual void | BinaryOn ()
| Turn on binary mode. More...
virtual void | BinaryOff ()
| Turn on binary mode. More...
virtual vtkTypeBool | GetBinary ()
| Turn on binary mode. More...
virtual void | SetFastest (vtkTypeBool)
| In binary mode use fastest instead of best compression. More...
virtual void | FastestOn ()
| In binary mode use fastest instead of best compression. More...
virtual void | FastestOff ()
| In binary mode use fastest instead of best compression. More...
virtual vtkTypeBool | GetFastest ()
| In binary mode use fastest instead of best compression. More...
virtual void | SetWriteToOutputString (vtkTypeBool)
| Enable writing to an OutputString instead of the default, a file. More...
virtual vtkTypeBool | GetWriteToOutputString ()
| Enable writing to an OutputString instead of the default, a file. More...
virtual void | WriteToOutputStringOn ()
| Enable writing to an OutputString instead of the default, a file. More...
virtual void | WriteToOutputStringOff ()
| Enable writing to an OutputString instead of the default, a file. More...
virtual vtkIdType | GetOutputStringLength ()
| When WriteToOutputString in on, then a string is allocated, written to, and can be retrieved with these methods. More...
virtual char * | GetOutputString ()
| When WriteToOutputString in on, then a string is allocated, written to, and can be retrieved with these methods. More...
unsigned char * | GetBinaryOutputString ()
| When WriteToOutputString in on, then a string is allocated, written to, and can be retrieved with these methods. More...
Public Member Functions inherited from vtkExporter
vtkExporter * | NewInstance () const
virtual void | Write ()
| Write data to output. More...
void | Update ()
| Convenient alias for Write() method. More...
void | SetStartWrite (void(*f)(void *), void *arg)
| Specify a function to be called before data is written. More...
void | SetEndWrite (void(*f)(void *), void *arg)
| Specify a function to be called after data is written. More...
void | SetStartWriteArgDelete (void(*f)(void *))
| Set the arg delete method. More...
void | SetEndWriteArgDelete (void(*f)(void *))
| Set the arg delete method. More...
vtkMTimeType | GetMTime () override
| Returns the MTime also considering the RenderWindow. More...
virtual void | SetRenderWindow (vtkRenderWindow *)
| Set/Get the rendering window that contains the scene to be written. More...
virtual vtkRenderWindow * | GetRenderWindow ()
| Set/Get the rendering window that contains the scene to be written. More...
virtual void | SetActiveRenderer (vtkRenderer *)
| Set/Get the renderer that contains actors to be written. More...
virtual vtkRenderer * | GetActiveRenderer ()
| Set/Get the renderer that contains actors to be written. More...
void | SetInput (vtkRenderWindow *renWin)
| These methods are provided for backward compatibility. More...
vtkRenderWindow * | GetInput ()
| These methods are provided for backward compatibility. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkX3DExporter * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkX3DExporter * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkExporter
static vtkTypeBool | IsTypeOf (const char *type)
static vtkExporter * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkX3DExporter ()
| ~vtkX3DExporter () override
void | WriteData () override
| Write data to output. More...
void | WriteALight (vtkLight *aLight, vtkX3DExporterWriter *writer)
void | WriteAnActor (vtkActor *anActor, vtkX3DExporterWriter *writer, int index)
void | WriteAPiece (vtkPolyData *piece, vtkActor *anActor, vtkX3DExporterWriter *writer, int index)
void | WritePointData (vtkPoints *points, vtkDataArray *normals, vtkDataArray *tcoords, vtkUnsignedCharArray *colors, vtkX3DExporterWriter *writer, int index)
void | WriteATextActor2D (vtkActor2D *anTextActor2D, vtkX3DExporterWriter *writer)
void | WriteATexture (vtkActor *anActor, vtkX3DExporterWriter *writer)
void | WriteAnAppearance (vtkActor *anActor, bool writeEmissiveColor, vtkX3DExporterWriter *writer)
virtual void | WriteAdditionalNodes (vtkX3DExporterWriter *vtkNotUsed(writer))
vtkTypeBool | HasHeadLight (vtkRenderer *ren)
Protected Member Functions inherited from vtkExporter
| vtkExporter ()
| ~vtkExporter () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkTypeBool | WriteToOutputString
char * | OutputString
vtkIdType | OutputStringLength
char * | FileName
double | Speed
vtkTypeBool | Binary
vtkTypeBool | Fastest
Protected Attributes inherited from vtkExporter
vtkRenderWindow * | RenderWindow
vtkRenderer * | ActiveRenderer
void(* | StartWrite )(void *)
void(* | StartWriteArgDelete )(void *)
void * | StartWriteArg
void(* | EndWrite )(void *)
void(* | EndWriteArgDelete )(void *)
void * | EndWriteArg
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

create an x3d file

vtkX3DExporter is a render window exporter which writes out the rendered scene into an X3D file. X3D is an XML-based format for representation 3D scenes (similar to VRML). Check out http://www.web3d.org/x3d/ for more details.

Thanks:
  X3DExporter is contributed by Christophe Mouton at EDF.

Online Examples:

Tests:
  vtkX3DExporter (Tests)

Definition at line 44 of file vtkX3DExporter.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkExporter vtkX3DExporter::Superclass

Definition at line 48 of file vtkX3DExporter.h.

## Constructor & Destructor Documentation

## ◆ vtkX3DExporter()

vtkX3DExporter::vtkX3DExporter | ( |  | ) |
| protected

## ◆ ~vtkX3DExporter()

vtkX3DExporter::~vtkX3DExporter | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkX3DExporter* vtkX3DExporter::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkX3DExporter::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkX3DExporter::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkExporter.

## ◆ SafeDownCast()

static vtkX3DExporter* vtkX3DExporter::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkX3DExporter::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkExporter.

## ◆ NewInstance()

vtkX3DExporter* vtkX3DExporter::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkX3DExporter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkExporter.

## ◆ vtkSetFilePathMacro()

vtkX3DExporter::vtkSetFilePathMacro | ( | FileName |  | ) |

Set/Get the output file name.

## ◆ vtkGetFilePathMacro()

vtkX3DExporter::vtkGetFilePathMacro | ( | FileName |  | ) |

Set/Get the output file name.

## ◆ SetSpeed()

virtual void vtkX3DExporter::SetSpeed | ( | double |  | ) |
| virtual

Specify the Speed of navigation.

Default is 4.

## ◆ GetSpeed()

virtual double vtkX3DExporter::GetSpeed | ( |  | ) |
| virtual

Specify the Speed of navigation.

Default is 4.

## ◆ SetBinary()

virtual void vtkX3DExporter::SetBinary | ( | vtkTypeBool |  | ) |
| virtual

Turn on binary mode.

## ◆ BinaryOn()

virtual void vtkX3DExporter::BinaryOn | ( |  | ) |
| virtual

Turn on binary mode.

## ◆ BinaryOff()

virtual void vtkX3DExporter::BinaryOff | ( |  | ) |
| virtual

Turn on binary mode.

## ◆ GetBinary()

virtual vtkTypeBool vtkX3DExporter::GetBinary | ( |  | ) |
| virtual

Turn on binary mode.

## ◆ SetFastest()

virtual void vtkX3DExporter::SetFastest | ( | vtkTypeBool |  | ) |
| virtual

In binary mode use fastest instead of best compression.

## ◆ FastestOn()

virtual void vtkX3DExporter::FastestOn | ( |  | ) |
| virtual

In binary mode use fastest instead of best compression.

## ◆ FastestOff()

virtual void vtkX3DExporter::FastestOff | ( |  | ) |
| virtual

In binary mode use fastest instead of best compression.

## ◆ GetFastest()

virtual vtkTypeBool vtkX3DExporter::GetFastest | ( |  | ) |
| virtual

In binary mode use fastest instead of best compression.

## ◆ SetWriteToOutputString()

virtual void vtkX3DExporter::SetWriteToOutputString | ( | vtkTypeBool |  | ) |
| virtual

Enable writing to an OutputString instead of the default, a file.

## ◆ GetWriteToOutputString()

virtual vtkTypeBool vtkX3DExporter::GetWriteToOutputString | ( |  | ) |
| virtual

Enable writing to an OutputString instead of the default, a file.

## ◆ WriteToOutputStringOn()

virtual void vtkX3DExporter::WriteToOutputStringOn | ( |  | ) |
| virtual

Enable writing to an OutputString instead of the default, a file.

## ◆ WriteToOutputStringOff()

virtual void vtkX3DExporter::WriteToOutputStringOff | ( |  | ) |
| virtual

Enable writing to an OutputString instead of the default, a file.

## ◆ GetOutputStringLength()

virtual vtkIdType vtkX3DExporter::GetOutputStringLength | ( |  | ) |
| virtual

When WriteToOutputString in on, then a string is allocated, written to, and can be retrieved with these methods.

The string is deleted during the next call to write ...

## ◆ GetOutputString()

virtual char* vtkX3DExporter::GetOutputString | ( |  | ) |
| virtual

When WriteToOutputString in on, then a string is allocated, written to, and can be retrieved with these methods.

The string is deleted during the next call to write ...

## ◆ GetBinaryOutputString()

unsigned char* vtkX3DExporter::GetBinaryOutputString | ( |  | ) |
| inline

When WriteToOutputString in on, then a string is allocated, written to, and can be retrieved with these methods.

The string is deleted during the next call to write ...

Definition at line 102 of file vtkX3DExporter.h.

## ◆ RegisterAndGetOutputString()

char* vtkX3DExporter::RegisterAndGetOutputString | ( |  | ) |

This convenience method returns the string, sets the IVAR to nullptr, so that the user is responsible for deleting the string.

I am not sure what the name should be, so it may change in the future.

## ◆ WriteData()

void vtkX3DExporter::WriteData | ( |  | ) |
| overrideprotectedvirtual

Write data to output.

Implements vtkExporter.

## ◆ WriteALight()

void vtkX3DExporter::WriteALight | ( | vtkLight * | aLight,
|  | vtkX3DExporterWriter * | writer
| ) |  |
| protected

## ◆ WriteAnActor()

void vtkX3DExporter::WriteAnActor | ( | vtkActor * | anActor,
|  | vtkX3DExporterWriter * | writer,
|  | int | index
| ) |  |
| protected

## ◆ WriteAPiece()

void vtkX3DExporter::WriteAPiece | ( | vtkPolyData * | piece,
|  | vtkActor * | anActor,
|  | vtkX3DExporterWriter * | writer,
|  | int | index
| ) |  |
| protected

## ◆ WritePointData()

void vtkX3DExporter::WritePointData | ( | vtkPoints * | points,
|  | vtkDataArray * | normals,
|  | vtkDataArray * | tcoords,
|  | vtkUnsignedCharArray * | colors,
|  | vtkX3DExporterWriter * | writer,
|  | int | index
| ) |  |
| protected

## ◆ WriteATextActor2D()

void vtkX3DExporter::WriteATextActor2D | ( | vtkActor2D * | anTextActor2D,
|  | vtkX3DExporterWriter * | writer
| ) |  |
| protected

## ◆ WriteATexture()

void vtkX3DExporter::WriteATexture | ( | vtkActor * | anActor,
|  | vtkX3DExporterWriter * | writer
| ) |  |
| protected

## ◆ WriteAnAppearance()

void vtkX3DExporter::WriteAnAppearance | ( | vtkActor * | anActor,
|  | bool | writeEmissiveColor,
|  | vtkX3DExporterWriter * | writer
| ) |  |
| protected

## ◆ WriteAdditionalNodes()

virtual void vtkX3DExporter::WriteAdditionalNodes | ( | vtkX3DExporterWriter * | vtkNotUsedwriter | ) |
| inlineprotectedvirtual

Definition at line 140 of file vtkX3DExporter.h.

## ◆ HasHeadLight()

vtkTypeBool vtkX3DExporter::HasHeadLight | ( | vtkRenderer * | ren | ) |
| protected

## Member Data Documentation

## ◆ WriteToOutputString

vtkTypeBool vtkX3DExporter::WriteToOutputString
| protected

Definition at line 120 of file vtkX3DExporter.h.

## ◆ OutputString

char* vtkX3DExporter::OutputString
| protected

Definition at line 121 of file vtkX3DExporter.h.

## ◆ OutputStringLength

vtkIdType vtkX3DExporter::OutputStringLength
| protected

Definition at line 122 of file vtkX3DExporter.h.

## ◆ FileName

char* vtkX3DExporter::FileName
| protected

Definition at line 144 of file vtkX3DExporter.h.

## ◆ Speed

double vtkX3DExporter::Speed
| protected

Definition at line 145 of file vtkX3DExporter.h.

## ◆ Binary

vtkTypeBool vtkX3DExporter::Binary
| protected

Definition at line 146 of file vtkX3DExporter.h.

## ◆ Fastest

vtkTypeBool vtkX3DExporter::Fastest
| protected

Definition at line 147 of file vtkX3DExporter.h.

The documentation for this class was generated from the following file:

- IO/Export/vtkX3DExporter.h